NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Features::MeshSurfaceBuilder Class Reference

Mesh Surface Builder class. More...

Inheritance diagram for NXOpen::Features::MeshSurfaceBuilder:
NXOpen::Features::FeatureBuilder NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder

Public Types

enum  ConstraintDirection { ConstraintDirectionNone, ConstraintDirectionIsoparametric, ConstraintDirectionNormal }
 End face constraints direction. More...
 
enum  ConstraintType { ConstraintTypeNone, ConstraintTypeTangent, ConstraintTypeCurvature }
 End face constraints types. More...
 

Public Member Functions

void BuildProfileFromSections (bool conehead, NXOpen::MeshProfileString::Type profileStringType, NXOpen::MeshParameterData::FeatureType skinType, NXOpen::MeshProfileString::SelectedPoint stringPointType, const std::vector< NXOpen::Section * > &sections, bool editInsertProfile, NXOpen::MeshProfileString *profile)
 Creates mesh surface profile string. More...
 
NXOpen::Features::MeshSurfaceBuilder::ConstraintDirection FaceConstraintDirection ()
 Returns
Created in NX4.0.0. More...
 
NXOpen::MeshParameterData::FeatureType FeatureType ()
 Returns
Created in NX4.0.0. More...
 
void GetAngleAlignmentPoints (NXOpen::Point3d *point1, NXOpen::Point3d *point2)
 Get angle alignment points
Created in NX4.0.0. More...
 
NXOpen::Vector3d GetDistanceAlignmentVector ()
 Get distance alignment vector. More...
 
void GetFaceConstraintCollectors (int nSides, std::vector< int > &facesCons, int numCollectors, std::vector< NXOpen::ScCollector * > &collectors, int numConsTypes, std::vector< NXOpen::Features::MeshSurfaceBuilder::ConstraintType > &consTypes)
 Get faces constraints collectors for through curves and curves mesh types surfaces. More...
 
std::vector
< NXOpen::Features::MeshSurfaceBuilder::ConstraintType
GetFaceConstraintTypes (int constraintSize)
 Get end constraints types. More...
 
NXOpen::MeshProfileStringGetProfile (int index)
 Get mesh profile string with provided index. More...
 
void GetProfilePointAlignment (int stringIndex, int arrayLength, std::vector< int > &alignIndex, std::vector< double > &alignParams)
 Get profile string point alignment info. More...
 
std::vector< double > GetTolerances (int tolLength)
 Get tolerances. More...
 
std::vector< NXStringGetToleranceString (int tolStrLength)
 Get tolerances strings. More...
 
void InsertProfileString (int profileIndex, NXOpen::MeshProfileString::InsertOrder order, int stringIndex)
 Insert a string (string_index, with order) into a profile (profile_index). More...
 
NXOpen::MeshParameterDataNewParametersData ()
 Create a mesh parameters transient object data. More...
 
NXOpen::MeshProfileStringNewProfile ()
 Construct a new mesh profile string transient object. More...
 
NXOpen::SurfaceRebuildDataNewRebuildData ()
 Allocate memory for Mesh type surface rebuild data. More...
 
bool NormalToEndSections ()
 Returns the normal to end sections for Through Curves surface. More...
 
NXOpen::MeshParameterDataParametersData ()
 Returns
Created in NX4.0.0. More...
 
NXOpen::SurfaceRebuildDataRebuildData ()
 Returns
Created in NX4.0.0. More...
 
void RemovePointsAlignment ()
 Remove points alignment information. More...
 
void RemoveProfileString (int profileIndex, int stringIndex)
 Remove a string (string_index) from a profile (profile_index)
Created in NX4.0.0. More...
 
void RemoveSpineAlignment ()
 Remove spine alignment. More...
 
void ReorderProfileStringCurves (int stringIndex, NXOpen::Curve *stringStartCurve)
 Reorder profile string curves. More...
 
void RestorePointsAlignment ()
 Restore the last removed points alignment information if there is one. More...
 
void SetAngleAlignmentPoints (const NXOpen::Point3d &point1, const NXOpen::Point3d &point2)
 Set angle alignment points. More...
 
void SetDistanceAlignmentVector (const NXOpen::Vector3d &vector)
 Set distance alignment vector
Created in NX4.0.0. More...
 
void SetFaceConstraintCollectors (const std::vector< int > &facesCons, const std::vector< NXOpen::ScCollector * > &collectors, const std::vector< NXOpen::Features::MeshSurfaceBuilder::ConstraintType > &consTypes)
 Set faces constraints collectors for through curves and curves mesh types surfaces. More...
 
void SetFaceConstraintDirection (NXOpen::Features::MeshSurfaceBuilder::ConstraintDirection constraintDirection)
 Sets
Created in NX4.0.0. More...
 
void SetFaceConstraintTypes (const std::vector< NXOpen::Features::MeshSurfaceBuilder::ConstraintType > &constraintTypes)
 Set end constraints types. More...
 
void SetFeatureType (NXOpen::MeshParameterData::FeatureType featureType)
 Sets
Created in NX4.0.0. More...
 
void SetNormalToEndSections (bool normalToEndSections)
 Sets the normal to end sections for Through Curves surface. More...
 
void SetParametersData (NXOpen::MeshParameterData *parameters)
 Sets
Created in NX4.0.0. More...
 
void SetProfilePointAlignment (int stringIndex, const std::vector< int > &alignIndex, const std::vector< double > &alignParams)
 Set profile string alignment info. More...
 
void SetRebuildData (NXOpen::SurfaceRebuildData *rbData)
 Sets
Created in NX4.0.0. More...
 
void SetSimpleConstruction (bool simple)
 Sets
Created in NX4.0.0. More...
 
void SetTolerances (const std::vector< double > &tol)
 Set tolerances for mesh type surfaces. More...
 
void SetToleranceString (std::vector< NXString > &tolString)
 Set tolerances strings for mesh type surface. More...
 
bool SimpleConstruction ()
 Returns
Created in NX4.0.0. More...
 
void ValidateFeatureParameters ()
 Validate the new parameters for mesh surface editing. More...
 
- Public Member Functions inherited from NXOpen::Features::FeatureBuilder
NXOpen::Features::FeatureCommitFeature ()
 Commits the feature parameters and creates the feature. More...
 
NXOpen::Features::FeatureGetFeature ()
 Returns the feature currently being edited by this builder. More...
 
void HideInternalParentFeatureAfterEdit (NXOpen::Features::Feature *parentFeature)
 Re-suppress an internal parent feature (a slave feature) after it has been edited. More...
 
bool ParentFeatureInternal ()
 Returns whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
bool PatchSolutionFlag ()
 Returns the patch solution flag
Created in NX8.0.1. More...
 
NXString PatchSurfaceFilename ()
 Returns the patch surface filename
Created in NX8.0.1. More...
 
void SetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the parent features which would be internal or slaves to the feature being created or commited
Created in NX6.0.0. More...
 
void SetParentFeatureInternal (bool isInternal)
 Sets whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
void SetPatchSolutionFlag (bool optionValue)
 Sets the patch solution flag
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const NXString &surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const char *surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const NXString &surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const char *surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void ShowInternalParentFeatureForEdit (NXOpen::Features::Feature *parentFeature)
 Unsuppress an internal parent feature (a slave feature) so it can be edited. More...
 
NXString SurroundingPatchSurfaceFilename ()
 Returns the surrounding patch surface filename
Created in NX8.0.1. More...
 
void UnsetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the internal parent feature of the feature being edited to external
Created in NX6.0.0. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Mesh Surface Builder class.


To create a new instance of this class, use NXOpen::Features::FeatureCollection::CreateMeshSurfaceBuilder

Created in NX4.0.0.

Member Enumeration Documentation

End face constraints direction.

Enumerator
ConstraintDirectionNone 

Not specified.

ConstraintDirectionIsoparametric 

Isoparametric.

ConstraintDirectionNormal 

Normal.

End face constraints types.

Enumerator
ConstraintTypeNone 

No constraint.

ConstraintTypeTangent 

Tangent.

ConstraintTypeCurvature 

Curvature.

Member Function Documentation

void NXOpen::Features::MeshSurfaceBuilder::BuildProfileFromSections ( bool  conehead,
NXOpen::MeshProfileString::Type  profileStringType,
NXOpen::MeshParameterData::FeatureType  skinType,
NXOpen::MeshProfileString::SelectedPoint  stringPointType,
const std::vector< NXOpen::Section * > &  sections,
bool  editInsertProfile,
NXOpen::MeshProfileString profile 
)

Creates mesh surface profile string.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
coneheadDisplay conehead?
profileStringTypeMesh profile string type
skinTypeMesh surface type
stringPointTypeProfile string point type
sectionsSections
editInsertProfileFlag to indicate if this is temporary profile to inserting new string purpose only.
profileMesh profile string
NXOpen::Features::MeshSurfaceBuilder::ConstraintDirection NXOpen::Features::MeshSurfaceBuilder::FaceConstraintDirection ( )

Returns
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

NXOpen::MeshParameterData::FeatureType NXOpen::Features::MeshSurfaceBuilder::FeatureType ( )

Returns
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

void NXOpen::Features::MeshSurfaceBuilder::GetAngleAlignmentPoints ( NXOpen::Point3d point1,
NXOpen::Point3d point2 
)

Get angle alignment points
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
point1Point 1
point2Point 2
NXOpen::Vector3d NXOpen::Features::MeshSurfaceBuilder::GetDistanceAlignmentVector ( )

Get distance alignment vector.

Returns
Vector
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
void NXOpen::Features::MeshSurfaceBuilder::GetFaceConstraintCollectors ( int  nSides,
std::vector< int > &  facesCons,
int  numCollectors,
std::vector< NXOpen::ScCollector * > &  collectors,
int  numConsTypes,
std::vector< NXOpen::Features::MeshSurfaceBuilder::ConstraintType > &  consTypes 
)

Get faces constraints collectors for through curves and curves mesh types surfaces.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
nSidesn sides
facesConsNumber of faces on each side
numCollectorsnum collectors
collectorsConstraints collectors.
numConsTypesnum cons types
consTypestype on each side.
std::vector<NXOpen::Features::MeshSurfaceBuilder::ConstraintType> NXOpen::Features::MeshSurfaceBuilder::GetFaceConstraintTypes ( int  constraintSize)

Get end constraints types.

Returns
Constraint types
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
Parameters
constraintSizeconstraint size
NXOpen::MeshProfileString* NXOpen::Features::MeshSurfaceBuilder::GetProfile ( int  index)

Get mesh profile string with provided index.

Returns
Requested profile data.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
Parameters
indexProfile index.
void NXOpen::Features::MeshSurfaceBuilder::GetProfilePointAlignment ( int  stringIndex,
int  arrayLength,
std::vector< int > &  alignIndex,
std::vector< double > &  alignParams 
)

Get profile string point alignment info.

Given a profile string, get alignment point parameters on segments indexed by align_index along the profile string.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
stringIndexstring index in profile strings
arrayLengtharray length
alignIndexAlignment indices
alignParamsAlignment parameters
std::vector<double> NXOpen::Features::MeshSurfaceBuilder::GetTolerances ( int  tolLength)

Get tolerances.

Returns

Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
Parameters
tolLengthtol length
std::vector<NXString> NXOpen::Features::MeshSurfaceBuilder::GetToleranceString ( int  tolStrLength)

Get tolerances strings.

Returns

Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
Parameters
tolStrLengthtol str length
void NXOpen::Features::MeshSurfaceBuilder::InsertProfileString ( int  profileIndex,
NXOpen::MeshProfileString::InsertOrder  order,
int  stringIndex 
)

Insert a string (string_index, with order) into a profile (profile_index).


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
profileIndexmesh profile string index
orderbefore or after
stringIndexString index in mesh profile string
NXOpen::MeshParameterData* NXOpen::Features::MeshSurfaceBuilder::NewParametersData ( )

Create a mesh parameters transient object data.

Returns
Allocated rebuild data.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
NXOpen::MeshProfileString* NXOpen::Features::MeshSurfaceBuilder::NewProfile ( )

Construct a new mesh profile string transient object.

Returns
New mesh profile string.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
NXOpen::SurfaceRebuildData* NXOpen::Features::MeshSurfaceBuilder::NewRebuildData ( )

Allocate memory for Mesh type surface rebuild data.

Returns
Allocated rebuild data.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")
bool NXOpen::Features::MeshSurfaceBuilder::NormalToEndSections ( )

Returns the normal to end sections for Through Curves surface.


Created in NX5.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

NXOpen::MeshParameterData* NXOpen::Features::MeshSurfaceBuilder::ParametersData ( )

Returns
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

NXOpen::SurfaceRebuildData* NXOpen::Features::MeshSurfaceBuilder::RebuildData ( )

Returns
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

void NXOpen::Features::MeshSurfaceBuilder::RemovePointsAlignment ( )

Remove points alignment information.

Remove alignment can be restore by calling Features::MeshSurfaceBuilder::RestorePointsAlignment
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

void NXOpen::Features::MeshSurfaceBuilder::RemoveProfileString ( int  profileIndex,
int  stringIndex 
)

Remove a string (string_index) from a profile (profile_index)
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
profileIndexmesh profile string index
stringIndexString index in mesh profile string
void NXOpen::Features::MeshSurfaceBuilder::RemoveSpineAlignment ( )

Remove spine alignment.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

void NXOpen::Features::MeshSurfaceBuilder::ReorderProfileStringCurves ( int  stringIndex,
NXOpen::Curve stringStartCurve 
)

Reorder profile string curves.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
stringIndexProfile string index.
stringStartCurveNew start curve.
void NXOpen::Features::MeshSurfaceBuilder::RestorePointsAlignment ( )

Restore the last removed points alignment information if there is one.

Once restored, the saved alignment information will no logner be available.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

void NXOpen::Features::MeshSurfaceBuilder::SetAngleAlignmentPoints ( const NXOpen::Point3d point1,
const NXOpen::Point3d point2 
)

Set angle alignment points.

Points will be used to evaluate the alignment angle.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
point1Point 1
point2Point 2
void NXOpen::Features::MeshSurfaceBuilder::SetDistanceAlignmentVector ( const NXOpen::Vector3d vector)

Set distance alignment vector
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
vectorVector
void NXOpen::Features::MeshSurfaceBuilder::SetFaceConstraintCollectors ( const std::vector< int > &  facesCons,
const std::vector< NXOpen::ScCollector * > &  collectors,
const std::vector< NXOpen::Features::MeshSurfaceBuilder::ConstraintType > &  consTypes 
)

Set faces constraints collectors for through curves and curves mesh types surfaces.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
facesConsNumber of faces on all sides
collectorsConstraints collectors.
consTypestype on each side.
void NXOpen::Features::MeshSurfaceBuilder::SetFaceConstraintDirection ( NXOpen::Features::MeshSurfaceBuilder::ConstraintDirection  constraintDirection)

Sets
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
constraintDirectionconstraint direction
void NXOpen::Features::MeshSurfaceBuilder::SetFaceConstraintTypes ( const std::vector< NXOpen::Features::MeshSurfaceBuilder::ConstraintType > &  constraintTypes)

Set end constraints types.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
constraintTypesConstraint types
void NXOpen::Features::MeshSurfaceBuilder::SetFeatureType ( NXOpen::MeshParameterData::FeatureType  featureType)

Sets
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
featureTypefeature type
void NXOpen::Features::MeshSurfaceBuilder::SetNormalToEndSections ( bool  normalToEndSections)

Sets the normal to end sections for Through Curves surface.


Created in NX5.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
normalToEndSectionsnormal to end sections
void NXOpen::Features::MeshSurfaceBuilder::SetParametersData ( NXOpen::MeshParameterData parameters)

Sets
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
parametersparameters
void NXOpen::Features::MeshSurfaceBuilder::SetProfilePointAlignment ( int  stringIndex,
const std::vector< int > &  alignIndex,
const std::vector< double > &  alignParams 
)

Set profile string alignment info.

For each profile string, user needs to spectify the point alignment parameters on segments indexed by align_index along the profile string.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
stringIndexstring index in profile strings
alignIndexAlignment indices
alignParamsAlignment parameters (normalized)
void NXOpen::Features::MeshSurfaceBuilder::SetRebuildData ( NXOpen::SurfaceRebuildData rbData)

Sets
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
rbDataRebuild data
void NXOpen::Features::MeshSurfaceBuilder::SetSimpleConstruction ( bool  simple)

Sets
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
simplesimple
void NXOpen::Features::MeshSurfaceBuilder::SetTolerances ( const std::vector< double > &  tol)

Set tolerances for mesh type surfaces.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
tolTolerances
void NXOpen::Features::MeshSurfaceBuilder::SetToleranceString ( std::vector< NXString > &  tolString)

Set tolerances strings for mesh type surface.

The strings much match the values.
Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

Parameters
tolStringTolerances
bool NXOpen::Features::MeshSurfaceBuilder::SimpleConstruction ( )

Returns
Created in NX4.0.0.



License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")

void NXOpen::Features::MeshSurfaceBuilder::ValidateFeatureParameters ( )

Validate the new parameters for mesh surface editing.


Created in NX4.0.0.

License requirements : features_modeling ("FEATURES MODELING"), nx_freeform_1 ("basic freeform modeling")


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.